diff --git a/sysdeps/ieee754/ldbl-opt/Makefile b/sysdeps/ieee754/ldbl-opt/Makefile
index d1eda5d022..81cb5b3a53 100644
--- a/sysdeps/ieee754/ldbl-opt/Makefile
+++ b/sysdeps/ieee754/ldbl-opt/Makefile
@@ -101,7 +101,6 @@ libnldbl-calls = \
   getpayload \
   hypot \
   ilogb \
-  iovfscanf \
   isinf \
   isnan \
   isoc23_fscanf \
@@ -428,11 +427,16 @@ endif
 
 ifeq ($(subdir), stdio-common)
 tests += \
+  test-nldbl-fscanf-redirect \
+  test-nldbl-fscanf-redirect-static \
   tst-nldbl-scanf-binary-c11 \
   tst-nldbl-scanf-binary-c23 \
   tst-nldbl-scanf-binary-gnu11 \
   tst-nldbl-scanf-binary-gnu89 \
 # tests
+tests-static += \
+  test-nldbl-fscanf-redirect-static \
+# tests-static
 
 # Some versions of GCC supported for building glibc do not support -std=c23
 # (added in GCC 14), or the older name -std=c2x (added in GCC 9), so
@@ -446,6 +450,12 @@ CFLAGS-tst-nldbl-scanf-binary-gnu11.c += -mlong-double-64 -std=gnu11 \
 					 -DOBJPFX=\"$(objpfx)\"
 CFLAGS-tst-nldbl-scanf-binary-gnu89.c += -mlong-double-64 -std=gnu89 \
 					 -DOBJPFX=\"$(objpfx)\"
+CFLAGS-test-nldbl-fscanf-redirect.c += -mlong-double-64
+CFLAGS-test-nldbl-fscanf-redirect-static.c += -mlong-double-64
+$(objpfx)test-nldbl-fscanf-redirect: \
+  $(common-objpfx)math/libnldbl_nonshared.a
+$(objpfx)test-nldbl-fscanf-redirect-static: \
+  $(common-objpfx)math/libnldbl_nonshared.a
 
 endif
 
diff --git a/sysdeps/ieee754/ldbl-opt/nldbl-compat.c b/sysdeps/ieee754/ldbl-opt/nldbl-compat.c
index f0bfb1e8a1..b05e47f185 100644
--- a/sysdeps/ieee754/ldbl-opt/nldbl-compat.c
+++ b/sysdeps/ieee754/ldbl-opt/nldbl-compat.c
@@ -1336,3 +1336,7 @@ compat_symbol (libc, __nldbl___fprintf_chk, __fprintf_chk, GLIBC_2_3_4);
 compat_symbol (libc, __nldbl___vprintf_chk, __vprintf_chk, GLIBC_2_3_4);
 compat_symbol (libc, __nldbl___vfprintf_chk, __vfprintf_chk, GLIBC_2_3_4);
 #endif
+#if SHLIB_COMPAT (libc, LONG_DOUBLE_COMPAT_VERSION, GLIBC_2_29)
+compat_symbol (libc, __nldbl__IO_vfscanf, __nldbl__IO_vfscanf,
+	       LONG_DOUBLE_COMPAT_VERSION);
+#endif
diff --git a/sysdeps/ieee754/ldbl-opt/nldbl-fscanf.c b/sysdeps/ieee754/ldbl-opt/nldbl-fscanf.c
index 00507187f3..8f762944b9 100644
--- a/sysdeps/ieee754/ldbl-opt/nldbl-fscanf.c
+++ b/sysdeps/ieee754/ldbl-opt/nldbl-fscanf.c
@@ -13,7 +13,7 @@ fscanf (FILE *stream, const char *fmt, ...)
   int done;
 
   va_start (arg, fmt);
-  done = __nldbl__IO_vfscanf (stream, fmt, arg, NULL);
+  done = __nldbl_vfscanf (stream, fmt, arg);
   va_end (arg);
 
   return done;
diff --git a/sysdeps/ieee754/ldbl-opt/nldbl-iovfscanf.c b/sysdeps/ieee754/ldbl-opt/nldbl-iovfscanf.c
deleted file mode 100644
index 6ed9b48624..0000000000
--- a/sysdeps/ieee754/ldbl-opt/nldbl-iovfscanf.c
+++ /dev/null
@@ -1,13 +0,0 @@
-/* This file defines one of the deprecated scanf variants.  */
-#include <features.h>
-#undef __GLIBC_USE_DEPRECATED_SCANF
-#define __GLIBC_USE_DEPRECATED_SCANF 1
-
-#include "nldbl-compat.h"
-
-int
-attribute_hidden
-_IO_vfscanf (FILE *s, const char *fmt, va_list ap, int *errp)
-{
-  return __nldbl__IO_vfscanf (s, fmt, ap, errp);
-}
diff --git a/sysdeps/ieee754/ldbl-opt/nldbl-scanf.c b/sysdeps/ieee754/ldbl-opt/nldbl-scanf.c
index c10da284f2..c7dd1b7bd0 100644
--- a/sysdeps/ieee754/ldbl-opt/nldbl-scanf.c
+++ b/sysdeps/ieee754/ldbl-opt/nldbl-scanf.c
@@ -13,7 +13,7 @@ scanf (const char *fmt, ...)
   int done;
 
   va_start (arg, fmt);
-  done = __nldbl__IO_vfscanf (stdin, fmt, arg, NULL);
+  done = __nldbl_vfscanf (stdin, fmt, arg);
   va_end (arg);
 
   return done;
diff --git a/sysdeps/ieee754/ldbl-opt/nldbl-vfscanf.c b/sysdeps/ieee754/ldbl-opt/nldbl-vfscanf.c
index 6f5ebc3045..076a06fe4f 100644
--- a/sysdeps/ieee754/ldbl-opt/nldbl-vfscanf.c
+++ b/sysdeps/ieee754/ldbl-opt/nldbl-vfscanf.c
@@ -9,7 +9,7 @@ int
 attribute_hidden
 __vfscanf (FILE *s, const char *fmt, va_list ap)
 {
-  return __nldbl__IO_vfscanf (s, fmt, ap, NULL);
+  return __nldbl_vfscanf (s, fmt, ap);
 }
 extern __typeof (__vfscanf) vfscanf attribute_hidden;
 weak_alias (__vfscanf, vfscanf)
diff --git a/sysdeps/ieee754/ldbl-opt/nldbl-vscanf.c b/sysdeps/ieee754/ldbl-opt/nldbl-vscanf.c
index 38f654aa73..7560ec5bac 100644
--- a/sysdeps/ieee754/ldbl-opt/nldbl-vscanf.c
+++ b/sysdeps/ieee754/ldbl-opt/nldbl-vscanf.c
@@ -10,5 +10,5 @@ attribute_hidden
 weak_function
 vscanf (const char *fmt, va_list ap)
 {
-  return __nldbl__IO_vfscanf (stdin, fmt, ap, NULL);
+  return __nldbl_vfscanf (stdin, fmt, ap);
 }
diff --git a/sysdeps/ieee754/ldbl-opt/test-nldbl-fscanf-redirect-static.c b/sysdeps/ieee754/ldbl-opt/test-nldbl-fscanf-redirect-static.c
new file mode 100644
index 0000000000..0e38f24b5a
--- /dev/null
+++ b/sysdeps/ieee754/ldbl-opt/test-nldbl-fscanf-redirect-static.c
@@ -0,0 +1 @@
+#include "test-nldbl-fscanf-redirect.c"
diff --git a/sysdeps/ieee754/ldbl-opt/test-nldbl-fscanf-redirect-static.input b/sysdeps/ieee754/ldbl-opt/test-nldbl-fscanf-redirect-static.input
new file mode 100644
index 0000000000..5551d71dab
--- /dev/null
+++ b/sysdeps/ieee754/ldbl-opt/test-nldbl-fscanf-redirect-static.input
@@ -0,0 +1,4 @@
+25 54.32E-1 thompson
+25 54.32E-1 thompson
+25 54.32E-1 thompson
+25 54.32E-1 thompson
diff --git a/sysdeps/ieee754/ldbl-opt/test-nldbl-fscanf-redirect.c b/sysdeps/ieee754/ldbl-opt/test-nldbl-fscanf-redirect.c
new file mode 100644
index 0000000000..ae1f0c1a4b
--- /dev/null
+++ b/sysdeps/ieee754/ldbl-opt/test-nldbl-fscanf-redirect.c
@@ -0,0 +1,21 @@
+/* Test fscanf/scanf/vfscanf/vscanf of long double as double without
+   <stdio.h>.
+   Copyright (C) 2024 Free Software Foundation, Inc.
+   This file is part of the GNU C Library.
+
+   The GNU C Library is free software; you can redistribute it and/or
+   modify it under the terms of the GNU Lesser General Public
+   License as published by the Free Software Foundation; either
+   version 2.1 of the License, or (at your option) any later version.
+
+   The GNU C Library is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+   Lesser General Public License for more details.
+
+   You should have received a copy of the GNU Lesser General Public
+   License along with the GNU C Library; if not, see
+   <https://www.gnu.org/licenses/>.  */
+
+#define EXPECTED_LONG_DOUBLE_VALUE 5.432
+#include <test-fscanf.c>
diff --git a/sysdeps/ieee754/ldbl-opt/test-nldbl-fscanf-redirect.input b/sysdeps/ieee754/ldbl-opt/test-nldbl-fscanf-redirect.input
new file mode 100644
index 0000000000..5551d71dab
--- /dev/null
+++ b/sysdeps/ieee754/ldbl-opt/test-nldbl-fscanf-redirect.input
@@ -0,0 +1,4 @@
+25 54.32E-1 thompson
+25 54.32E-1 thompson
+25 54.32E-1 thompson
+25 54.32E-1 thompson